##########################################################
##                                                      ##
## INSTALL PROCEDURE FOR CMF/PLONE TYPES                ##
##                                                      ##
## This can be shared across IW products ! :-)          ##
## Just edit the tagged lines (## EDIT)                 ##
##                                                      ##
##########################################################

from Products.PlonePopoll import install_globals
from Products.PlonePopoll import PlonePopoll
from Products.PlonePopoll.global_symbols import *
from Products.PlonePopoll.Installation import Installation

from Products.CMFCore.utils import getToolByName 

from cStringIO import StringIO
import string



# EDIT FROM HERE...
fti_list =  (
    PlonePopoll.factory_type_information,
    )
fti_list2 =  (
    PlonePopoll.factory_type_information2,
    )
types_list = (
    "PlonePopoll",
    )

#skin_names = ["PlonePopoll/sources", "PlonePopoll" ]
skin_name = "PlonePopoll"

tools = (
    "PlonePopoll Tool", 
    )
product_name = "PlonePopoll"
i18n_name = "PlonePopoll"
# ...TO HERE

def setupCustomSlots(self, out):
   """ sets up the custom slots"""
   #use the right zpt
   installation = Installation(self)
   if installation.isPlone2():
      popoll_slot='here/popoll_slot2/macros/popollBox'
   else:
      popoll_slot='here/popoll_slot/macros/popollBox'  
   if hasattr(self, "right_slots"):
       if popoll_slot in self.right_slots:
          out.write("Right slot for popoll exists already\n")
       else:
          right_slots_list=list(self.right_slots)
          self._delProperty('right_slots')
          right_slots_list.append(popoll_slot)
          self._setProperty('right_slots',tuple(right_slots_list),'lines')
          out.write("Added right slot for popoll\n")


def setupTools(self, out):
    addTool = self.manage_addProduct[product_name].manage_addTool
    for tool in tools:
        found = 0
        for obj in self.objectValues():
            if obj.meta_type == tool:
                found = 1
                
        if found:
            PlonePopollTool = getToolByName(self, 'portal_popoll')
            backend = PlonePopollTool.getBackend()
            #doMigration(self, backend)
            out.write("Migration to PlonePoll -multiple choice edition- successful.")

        if not found:
            addTool(tool, None)
            self.portal_popoll.manage_addProduct['PlonePopoll'].manage_addPlonePopollZODBBackend()
            out.write("Added '%s' tool.\n" % (tool,))


def doMigration(self, backend):
    """
   #Migrate Results of PlonePopoll 2.0x or lower to 2.1
   #In version 2.0x or lower : choice of user was stored as Integer
   #In version 2.1 : choice of user is stored as a list of choice
   #Get all results in PlonePopollBackend and change the type of stored choice
    """
    PlonePopollTool = getToolByName(self, 'portal_popoll')
    backend = PlonePopollTool.getBackend()
    storedResults = backend._getResults()
    #add if non existant
    if not hasattr(backend.aq_explicit, '_internal_version'):
        backend.aq_explicit._internal_version = 0
    #do changes for 2.0x to 2.1
    if backend.aq_explicit._internal_version < 1:
        backend.aq_explicit._internal_version = 1
        for poll_id in storedResults:
             for user in storedResults[poll_id]:
                choices = storedResults[poll_id][user]
                if not type(choices) == type([]):
                     storedResults[poll_id][user] = [choices]
        backend._results = storedResults
    
def install(self):
    out=StringIO()
    installation=Installation(self)
    installation.setupTypesandSkins(fti_list, skin_name, install_globals, fti_list2)
    setupTools(self, out)    
    setupCustomSlots(self, out)
    domain=string.lower(i18n_name)
    poPrefix='%s_' % (string.lower(i18n_name), )
    if not installation.isPlone2():
        for ctype in types_list:
            validation = [
                  ('%s_editForm' % (ctype), 'validate_id,validate_%s_edit' % ctype, ),
                ]
            installation.addFormValidators(validation)
            lowertype=ctype.lower()
            transitions = [
                  ('%s.%s_editForm.success' % (lowertype, ctype ), 'script:%s_edit' % (ctype), ),
                ('%s.%s_editForm.failure' % (lowertype, ctype ), '%s_editForm' % (ctype), ),
                ('%s.%s_edit.success' % (lowertype, ctype ), 'action:view', ),
                ('%s.%s_edit.failure' % (lowertype, ctype ), 'action:edit', ),
                ]
            installation.addNavigationTransitions(transitions)
    #installation.installMessageCatalog(self, install_globals, domain, poPrefix)
    
    try:
        self.portal_controlpanel.registerConfiglet(**prefs_plonepopoll_configlet)
    except KeyError:
        pass

    PROJECTNAME=product_name
    provider = getToolByName(self, 'portal_selenium', None)
    if provider:
        # Functional Tests
        action = {'id':PROJECTNAME.lower(),
                  'name':PROJECTNAME,
                  'action':'string:here/get_%s_ftests'%PROJECTNAME.lower(),
                  'condition': '',
                  'permission': 'View',
                  'category':'ftests',
                  'visible': 1}
        provider.addAction(**action)

    typesTool = getToolByName(self, 'portal_types')
    # Set the human readable title explicitly
    t = getattr(typesTool, 'PlonePopoll', None)
    if t:
        t.title = 'Poll'


    return installation.report()



def uninstall(self):
    out = StringIO()
    
    # uninstall configlets
    try:
        self.portal_controlpanel.unregisterApplication(PROJECTNAME)
    except:
        pass
    
    out.write("PlonePopoll configlet successfully uninstalled.")
    return out.getvalue()

