"""
Create in your plone site folder (from zmi) an external method
Module : PlonePopoll.doMigration
method : doMigration

save and test
"""

from Products.CMFCore.utils import getToolByName 


def doMigration(self,):
    """
   #Migrate Results of PlonePopoll 2.0x or lower to 2.1
   #In version 2.0x or lower : choice of user was stored as Integer
   #In version 2.1 : choice of user is stored as a list of choice
   #Get all results in PlonePopollBackend and change the type of stored choice
    """
    msg = ''
    PlonePopollTool = getToolByName(self, 'portal_popoll')
    backend = PlonePopollTool.getBackend()
    storedResults = backend._getResults()
    #add if non existant
    if not hasattr(backend.aq_explicit, '_internal_version'):
        backend.aq_explicit._internal_version = 0
    #do changes for 2.0x to 2.1
    if backend.aq_explicit._internal_version < 1:
        backend.aq_explicit._internal_version = 1
        for poll_id in storedResults:
             for user in storedResults[poll_id]:
                choices = storedResults[poll_id][user]
                if not type(choices) == type([]):
                     storedResults[poll_id][user] = [choices]
        backend._results = storedResults
        msg = msg + '\nInternal version set to 1.'
    msg = msg + '\nMigration done.'
    return msg

