##############################################################################
#
# Copyright (c) 2002 Ingeniweb SARL
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

"""PlonePopoll product"""

from global_symbols import *

from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils, CMFCorePermissions
from Products.PlonePopoll import Permissions

import PlonePopoll
import PlonePopollTool
import PlonePopollBackend

registerDirectory('skins', globals())
registerDirectory('skins/PlonePopoll', globals())

install_globals = globals()          # Used only in the Extensions/Install.py script


# Classes & constructors declaration
contentClasses = (PlonePopoll.PlonePopoll, )
contentConstructors = (PlonePopoll.addPlonePopoll, )


# Initialization method
def initialize(context):
    utils.ContentInit(
        'A simple polling type',
        content_types = contentClasses,
        permission = Permissions.PlonePopoll_addPermission,
        extra_constructors = contentConstructors,
        fti = (PlonePopoll.factory_type_information,),
        ).initialize(context)

    utils.ToolInit(
        'PlonePopoll Tool',
        tools=(PlonePopollTool.PlonePopollTool,),
        product_name='PlonePopoll',
        icon='tool.gif',
        ).initialize( context )

    # This has to be improved so that only PlonePopollManager objects can hold PlonePopollBackends
    # and PlonePopollBackends can be derived.
    context.registerClass(
        PlonePopollBackend.PlonePopollZODBBackend,
        permission='Add PlonePopollManagers',
        constructors=(PlonePopollBackend.manage_addPlonePopollZODBBackend,),
        visibility=None,
        icon='www/PlonePopollBackend.gif',
        )

    context.registerClass(
        PlonePopollBackend.PlonePopollZSQLBackend,
        permission='Add PlonePopollManagers',
        constructors=(PlonePopollBackend.manage_addPlonePopollZSQLBackend,),
        visibility=None,
        icon='www/PlonePopollBackend.gif',
        )

