## Script (Python) "prefs_PlonePopoll_getPortletPoll"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=choice=None
##title=Get poll to display in portlet
##
from Products.CMFCore.utils import getToolByName

DEFAULT_PORTLET_CONFIG = 'newest'
results = []
poll = None
portal_popoll = getToolByName(context, 'portal_popoll')
portlet_configuration = portal_popoll.getPortletConfiguration()

#nothing has been set
if not portlet_configuration:
    portlet_configuration = DEFAULT_PORTLET_CONFIG

#we don't want to see the portlet -> return Nothing
if portlet_configuration == 'hidden':
    return []

#see the last published
elif portlet_configuration == 'newest':
    results = context.portal_catalog.searchResults(portal_type='PlonePopoll',
                                                   sort_on='Date',
                                                   sort_order='reverse',
                                                   review_state='published')[:1]

#see the last published in the current folder
elif portlet_configuration == 'branch':
    folder = context
    if not context.isPrincipiaFolderish:
        folder = context.aq_explicit.getParentNode()
    
    results = folder.contentValues(
                    filter={'portal_type':'PlonePopoll', 
                            'review_state': 'published'
                           }, 
              )
    sort_on = (('effective', 'cmp', 'desc'), )
    if results:
        results = sequence.sort(results, sort_on)
        poll = results[0]


#see the last published in the current folder OR in its sub-folder
elif portlet_configuration == 'subbranches':
    folder = context
    if not context.isPrincipiaFolderish:
        folder = context.aq_explicit.getParentNode()
        
    results = context.portal_catalog.searchResults(portal_type='PlonePopoll',
                                                   path='/'.join(folder.getPhysicalPath()),
                                                   sort_on='Date',
                                                   sort_order='reverse',
                                                   review_state='published')[:1]
else:
    # Path to plonePopoll object
    results = context.portal_catalog.searchResults(portal_type='PlonePopoll',
                                                   path=portlet_configuration,
                                                   review_state='published')[:1]
    

if not poll and len(results) == 1:
    poll = results[0].getObject()

if poll:
   return [poll]

return []
