## Script (Python) "get_plonepopoll_ftests"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
selenium = context.portal_selenium
suite = selenium.getSuite()
target_language='en'
suite.setTargetLanguage(target_language)

selenium.addUser(id = 'sampleadmin',fullname='Sample Admin',roles=['Member', 'Manager',])
selenium.addUser(id = 'samplemember',fullname='Sample Member',roles=['Member',])

test_logout = suite.TestLogout()
test_admin_login  = suite.TestLoginPortlet('sampleadmin')
test_member_login  = suite.TestLoginPortlet('samplemember')
test_switch_language = suite.TestSwitchToLanguage()

plone21 = selenium.getPloneVersion() > "2.0.5"

if plone21:
    delete_from_folder = "/folder_delete?paths:list=" + suite.getTest().base + '/'
else:
    delete_from_folder = "/folder_delete?ids:list="

suite.addTests("PlonePopoll",
    'Login as Sample Admin',
    test_admin_login,
    test_switch_language,
    'Admin adds Poll',
    suite.open(delete_from_folder + 'plonepoll'),
     suite.open("/"),
    suite.clickAndWait( "//a[contains(text(),'View')]"),
    suite.clickAndWait( "link=Poll"),
    suite.verifyTextPresent("PlonePopoll has been created."),
    suite.type("name=id","plonepoll"),
    suite.clickAndWait("name=form.button.Save"),
    suite.verifyTextPresent("Please correct the indicated errors."),
    suite.verifyTextPresent("At least two answers are needed for the Poll."),
    suite.type("name=title","Opinion Poll"),
    suite.type("name=question","What is your opinion?"),
    suite.clickAndWait("name=form.button.Save"),
    suite.verifyTextPresent("Please correct the indicated errors."),
    suite.verifyTextPresent("At least two answers are needed for the Poll."),
    suite.type("name=answers:lines","Answer 1<br />Answer 2<br />Answer 3"),
    suite.type("name=number","0"),
    suite.clickAndWait("name=form.button.Save"),
    suite.verifyTextPresent("Number of possible choices must be between one and the number of answers."),
    suite.type("name=number","4"),
    suite.clickAndWait("name=form.button.Save"),
    suite.verifyTextPresent("Number of possible choices must be between one and the number of answers."),
    suite.type("name=number","1"),
    suite.clickAndWait("name=form.button.Save"),
    suite.verifyTextPresent("Poll changes saved."),
    "Admin votes",
    suite.open("/plonepoll"),
     )

return suite
